/*Author James_r <ruanbeihong@gmail.com>*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include <time.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <pthread.h>

#include "benchmark.h"

#define TIME 4
extern int errno;

int alarmsig=0;

void stop()
{
		alarmsig=1;
		signal(SIGALRM,stop);
}

int do_1e6CHAR_AM()
{
		char b=3;
		char a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1+=(b+13%i);
				a2+=(b+13%i);
				a3+=(b+13%i);
				a4+=(b+13%i);
				a5+=(b+13%i);
				a6+=(b+13%i);
				a7+=(b+13%i);
				a8+=(b+13%i);
				a1-=(13%i);
				a2-=(13%i);
				a3-=(13%i);
				a4-=(13%i);
				a5-=(13%i);
				a6-=(13%i);
				a7-=(13%i);
				a8-=(13%i);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6CHAR_MD()
{
		char b=3;
		char a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1*=(b+13%i);
				a2*=(b+13%i);
				a3*=(b+13%i);
				a4*=(b+13%i);
				a5*=(b+13%i);
				a6*=(b+13%i);
				a7*=(b+13%i);
				a8*=(b+13%i);
				a1/=(13%i+1);
				a2/=(13%i+1);
				a3/=(13%i+1);
				a4/=(13%i+1);
				a5/=(13%i+1);
				a6/=(13%i+1);
				a7/=(13%i+1);
				a8/=(13%i+1);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}


int do_1e6SHORT_AM()
{
		short b=3;
		short a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1+=(b+13%i);
				a2+=(b+13%i);
				a3+=(b+13%i);
				a4+=(b+13%i);
				a5+=(b+13%i);
				a6+=(b+13%i);
				a7+=(b+13%i);
				a8+=(b+13%i);
				a1-=(13%i);
				a2-=(13%i);
				a3-=(13%i);
				a4-=(13%i);
				a5-=(13%i);
				a6-=(13%i);
				a7-=(13%i);
				a8-=(13%i);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6SHORT_MD()
{
		short b=3;
		short a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1*=(b+13%i);
				a2*=(b+13%i);
				a3*=(b+13%i);
				a4*=(b+13%i);
				a5*=(b+13%i);
				a6*=(b+13%i);
				a7*=(b+13%i);
				a8*=(b+13%i);
				a1/=(13%i+1);
				a2/=(13%i+1);
				a3/=(13%i+1);
				a4/=(13%i+1);
				a5/=(13%i+1);
				a6/=(13%i+1);
				a7/=(13%i+1);
				a8/=(13%i+1);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}


int do_1e6INT_AM()
{
		int b=3;
		int a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1+=(b+13%i);
				a2+=(b+13%i);
				a3+=(b+13%i);
				a4+=(b+13%i);
				a5+=(b+13%i);
				a6+=(b+13%i);
				a7+=(b+13%i);
				a8+=(b+13%i);
				a1-=(13%i);
				a2-=(13%i);
				a3-=(13%i);
				a4-=(13%i);
				a5-=(13%i);
				a6-=(13%i);
				a7-=(13%i);
				a8-=(13%i);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6INT_MD()
{
		int b=3;
		int a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1*=(b+13%i);
				a2*=(b+13%i);
				a3*=(b+13%i);
				a4*=(b+13%i);
				a5*=(b+13%i);
				a6*=(b+13%i);
				a7*=(b+13%i);
				a8*=(b+13%i);
				a1/=(13%i+1);
				a2/=(13%i+1);
				a3/=(13%i+1);
				a4/=(13%i+1);
				a5/=(13%i+1);
				a6/=(13%i+1);
				a7/=(13%i+1);
				a8/=(13%i+1);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}


int do_1e6LONG_AM()
{
		long b=3;
		long a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1+=(b+13%i);
				a2+=(b+13%i);
				a3+=(b+13%i);
				a4+=(b+13%i);
				a5+=(b+13%i);
				a6+=(b+13%i);
				a7+=(b+13%i);
				a8+=(b+13%i);
				a1-=(13%i);
				a2-=(13%i);
				a3-=(13%i);
				a4-=(13%i);
				a5-=(13%i);
				a6-=(13%i);
				a7-=(13%i);
				a8-=(13%i);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6LONG_MD()
{
		long b=3;
		long a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1*=(b+13%i);
				a2*=(b+13%i);
				a3*=(b+13%i);
				a4*=(b+13%i);
				a5*=(b+13%i);
				a6*=(b+13%i);
				a7*=(b+13%i);
				a8*=(b+13%i);
				a1/=(13%i+1);
				a2/=(13%i+1);
				a3/=(13%i+1);
				a4/=(13%i+1);
				a5/=(13%i+1);
				a6/=(13%i+1);
				a7/=(13%i+1);
				a8/=(13%i+1);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}


int do_1e6LONG_LONG_AM()
{
		long long b=3;
		long long a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1+=(b+13%i);
				a2+=(b+13%i);
				a3+=(b+13%i);
				a4+=(b+13%i);
				a5+=(b+13%i);
				a6+=(b+13%i);
				a7+=(b+13%i);
				a8+=(b+13%i);
				a1-=(13%i);
				a2-=(13%i);
				a3-=(13%i);
				a4-=(13%i);
				a5-=(13%i);
				a6-=(13%i);
				a7-=(13%i);
				a8-=(13%i);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6LONG_LONG_MD()
{
		long long b=3;
		long long a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1*=(b+13%i);
				a2*=(b+13%i);
				a3*=(b+13%i);
				a4*=(b+13%i);
				a5*=(b+13%i);
				a6*=(b+13%i);
				a7*=(b+13%i);
				a8*=(b+13%i);
				a1/=(13%i+1);
				a2/=(13%i+1);
				a3/=(13%i+1);
				a4/=(13%i+1);
				a5/=(13%i+1);
				a6/=(13%i+1);
				a7/=(13%i+1);
				a8/=(13%i+1);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}


int do_1e6FLOAT_AM()
{
		float b=3.0;
		float a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1+=(b+13%i);
				a2+=(b+13%i);
				a3+=(b+13%i);
				a4+=(b+13%i);
				a5+=(b+13%i);
				a6+=(b+13%i);
				a7+=(b+13%i);
				a8+=(b+13%i);
				a1-=(13%i);
				a2-=(13%i);
				a3-=(13%i);
				a4-=(13%i);
				a5-=(13%i);
				a6-=(13%i);
				a7-=(13%i);
				a8-=(13%i);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6FLOAT_MD()
{
		float b=3.0;
		float a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1*=(b+13%i);
				a2*=(b+13%i);
				a3*=(b+13%i);
				a4*=(b+13%i);
				a5*=(b+13%i);
				a6*=(b+13%i);
				a7*=(b+13%i);
				a8*=(b+13%i);
				a1/=(13%i+1);
				a2/=(13%i+1);
				a3/=(13%i+1);
				a4/=(13%i+1);
				a5/=(13%i+1);
				a6/=(13%i+1);
				a7/=(13%i+1);
				a8/=(13%i+1);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}


int do_1e6DOUBLE_AM()
{
		double b=3.0;
		double a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1+=(b+13%i);
				a2+=(b+13%i);
				a3+=(b+13%i);
				a4+=(b+13%i);
				a5+=(b+13%i);
				a6+=(b+13%i);
				a7+=(b+13%i);
				a8+=(b+13%i);
				a1-=(13%i);
				a2-=(13%i);
				a3-=(13%i);
				a4-=(13%i);
				a5-=(13%i);
				a6-=(13%i);
				a7-=(13%i);
				a8-=(13%i);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6DOUBLE_MD()
{
		double b=3.0;
		double a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1*=(b+13%i);
				a2*=(b+13%i);
				a3*=(b+13%i);
				a4*=(b+13%i);
				a5*=(b+13%i);
				a6*=(b+13%i);
				a7*=(b+13%i);
				a8*=(b+13%i);
				a1/=(13%i+1);
				a2/=(13%i+1);
				a3/=(13%i+1);
				a4/=(13%i+1);
				a5/=(13%i+1);
				a6/=(13%i+1);
				a7/=(13%i+1);
				a8/=(13%i+1);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6L_DOUBLE_AM()
{
		long double b=3.0;
		long double a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1+=(b+13%i);
				a2+=(b+13%i);
				a3+=(b+13%i);
				a4+=(b+13%i);
				a5+=(b+13%i);
				a6+=(b+13%i);
				a7+=(b+13%i);
				a8+=(b+13%i);
				a1-=(13%i);
				a2-=(13%i);
				a3-=(13%i);
				a4-=(13%i);
				a5-=(13%i);
				a6-=(13%i);
				a7-=(13%i);
				a8-=(13%i);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}

int do_1e6L_DOUBLE_MD()
{
		long double b=3.0;
		long double a1,a2,a3,a4,a5,a6,a7,a8;
		a1=a2=a3=a4=a5=a6=a7=a8=b;
		register int i;
		for(i=1;i<=125000;i++)
		{
				a1*=(b+13%i);
				a2*=(b+13%i);
				a3*=(b+13%i);
				a4*=(b+13%i);
				a5*=(b+13%i);
				a6*=(b+13%i);
				a7*=(b+13%i);
				a8*=(b+13%i);
				a1/=(13%i+1);
				a2/=(13%i+1);
				a3/=(13%i+1);
				a4/=(13%i+1);
				a5/=(13%i+1);
				a6/=(13%i+1);
				a7/=(13%i+1);
				a8/=(13%i+1);
				b=3%i;
		}
		return (a1+a2+a3+a4+a5+a6+a7+a8);
}


#define test(op) void* test##op(void *out)\
{\
		int i=0;\
		while(alarmsig==0)\
		{\
				i++;\
				((threadinfo*)out)->junk=do_1e6##op();\
		}\
		((threadinfo*)out)->result=(double)i*4.0/TIME;\
		pthread_exit(0);\
}\


test(CHAR_AM)
test(CHAR_MD)
test(SHORT_AM)
test(SHORT_MD)
test(INT_AM)
test(INT_MD)
test(LONG_AM)
test(LONG_MD)
test(LONG_LONG_AM)
test(LONG_LONG_MD)
test(FLOAT_AM)
test(FLOAT_MD)
test(DOUBLE_AM)
test(DOUBLE_MD)
test(L_DOUBLE_AM)
test(L_DOUBLE_MD)


int main(int argc, char** argv)
{
		int i=0,a,j;
		double s=0.0;
		if(argc!=2)
		{
				printf("Usage: %s thread_num\n",argv[0]);
				exit(1);
		}
		a=atoi(argv[1]);
		threadinfo tif[a];

		signal(SIGALRM,stop);

		printf("Thread num: %d\n=======================\n",a);

#define run(str1,func,type)\
do{\
printf(str1);\
while(i<a)\
{\
	pthread_create(&(tif[i].thread),NULL,func,(void*)&tif[i]);\
	i++;\
}\
alarm(TIME);\
for(i=0;i<a;i++)\
{\
	pthread_join(tif[i].thread,NULL);\
	s+=tif[i].result;\
}\
printf("sizeof "#type":%d\nscore:%4f\n",sizeof(type),s);\
alarmsig=0;s=0.0;i=0;\
fflush(stdout);sleep(1);}while(0)

run("Test:char +-%\t",testCHAR_AM,char);
run("Test:char */%\t",testCHAR_MD,char);
run("Test:short +-%\t",testSHORT_AM,short);
run("Test:short */%\t",testSHORT_MD,short);
run("Test:int +-%\t",testINT_AM,int);
run("Test:int */%\t",testINT_MD,int);
run("Test:long +-%\t",testLONG_AM,long);
run("Test:long */%\t",testLONG_MD,long);
run("Test:long long +-%\t",testLONG_LONG_AM,long long);
run("Test:long long */%\t",testLONG_LONG_MD,long long);
run("Test:float +-%\t",testFLOAT_AM,float);
run("Test:float */%\t",testFLOAT_MD,float);
run("Test:double +-%\t",testDOUBLE_AM,double);
run("Test:double */%\t",testDOUBLE_MD,double);
run("Test:long double +-%\t",testL_DOUBLE_AM,long double);
run("Test:long double */%\t",testL_DOUBLE_MD,long double);

}

